#pragma once

#include "quark/Layer.hpp"
#include "quark/events/Event.hpp"
#include "quark/events/MouseEvent.hpp"
#include "quark/events/KeyEvent.hpp"
#include "quark/events/ApplicationEvent.hpp"

namespace qk {
	class ImGuiLayer :
		public Layer
	{
	public:
		ImGuiLayer();
		~ImGuiLayer();

		void OnAttach() override;
		void OnDetach() override;

		void OnUpdate() override;
		void OnEvent(Event& event) override;

	private:
		bool OnMouseButtonPressed(MouseButtonPressedEvent& e);
		bool OnMouseButtonReleased(MouseButtonReleasedEvent& e);
		bool OnMouseMoved(MouseMovedEvent& e);
		bool OnMouseScrolled(MouseScrolledEvent& e);

		bool OnKeyPressedEvent(KeyPressedEvent& e);
		bool OnKeyReleasedEvent(KeyReleasedEvent& e);
		bool OnKeyTypedEvent(KeyTypedEvent& e);
		
		bool OnWindowResized(WindowResizeEvent& e);

	private:
		float lastTime = 0.0f;
	};
}
